/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... pretezovani funkci, sablony
*/

#include<iostream>
#include<string>
#include "Uloziste3.h"
#include "Uloziste4.h"

using namespace std;

#define CISLO
#ifdef  CISLO
using T1 = int;
#endif //  CISLO

void vypis(int x)
{
	cout << "int: " << x << endl;
}

void vypis(const string& x)
{
	cout << "string: " << x << endl;
}

/* sablona funkce: */
template<typename T>
void vypis(T x)
{
	cout << "nejaky datovy typ: " << x << endl;
}

/* sablona funkce s typovym a hodnotovym parametrem: */
template<typename T, int n> 
void prohod(T *a, T *b)
{
	T p;
	for (int i = 0; i < n; i++)
	{
		p = a[i];
		a[i] = b[i];
		b[i] = p;
	}
}

/* sablona struktury: */
template<typename T>
struct Uloziste
{
	T data;
};

/* sablona tridy: */
template<typename T>
class Uloziste2
{
	T data;
public:
	Uloziste2(T data)
	{
		this->data = data;
	}
	void nastavData(T data)
	{
		this->data = data;
	}
	T vratData()
	{
		return data;
	}
};

/* sablona tridy (deklarace metod mimo telo sablony): */
template<typename T>
class Uloziste1
{
	T data;
public:
	Uloziste1(T data);
	void nastavData(T data);
	T vratData();
};

template<typename T>
Uloziste1<T>::Uloziste1(T data)
{
	this->data = data;
}

template<typename T>
void Uloziste1<T>::nastavData(T data)
{
	this->data = data;
}

template<typename T>
T Uloziste1<T>::vratData()
{
	return data;
}

int main()
{
	{
		vypis(6);
		vypis<int>(89);
		vypis(3.45);
		vypis<float>(3.45);
		vypis<string>("jsgdf");
		string s = "abc";
		vypis(s);
		T1 a = 9;
		vypis(a);
	}
	{
		char x[] = "abc";
		char y[] = "xyzqw";

		prohod<char, 2>(x, y);
		prohod<char, 3>(x, y);
		for (int i = 0; i < 3; i++)
			cout << x[i];
		cout << endl;
		for (int i = 0; i < 5; i++)
			cout << y[i];
		cout << endl;
	}
	{
		cout << max(2, -3) << endl;
		cout << max<int>(2, -3) << endl;
		cout << max<int>(2.56, 4.01) << endl;
		cout << max('a', 'A') << endl;
		cout << max<string>("abc", "ABC") << endl;
	}
	{
		Uloziste<int> batoh;
		batoh.data = 8;
		cout << batoh.data << endl;

		Uloziste<float> batoh1;
		batoh1.data = 8.7;
		cout << batoh1.data << endl;

		Uloziste<string>* batoh2 = new Uloziste<string>;
		batoh2->data = "abc";
		cout << batoh2->data << endl;
		delete batoh2;
	}
	{
		Uloziste1<int> batoh(8);
		batoh.nastavData(10);
		cout << batoh.vratData() << endl;

		Uloziste1<float> batoh1(3.45);
		cout << batoh1.vratData() << endl;

		Uloziste1<string>* batoh2 = new Uloziste1<string>("sfdg");
		cout << batoh2->vratData() << endl;

		delete batoh2;
	}
	{
		Uloziste2<int> batoh(8);
		batoh.nastavData(10);
		cout << batoh.vratData() << endl;

		Uloziste2<float> batoh1(3.45);
		cout << batoh1.vratData() << endl;

		Uloziste2<string>* batoh2 = new Uloziste2<string>("sfdg");
		cout << batoh2->vratData() << endl;

		delete batoh2;
	}
	{
		Uloziste3<int> batoh(8);
		batoh.nastavData(10);
		cout << batoh.vratData() << endl;

		Uloziste3<float> batoh1(3.45);
		cout << batoh1.vratData() << endl;

		Uloziste3<string>* batoh2 = new Uloziste3<string>("sfdg");
		cout << batoh2->vratData() << endl;

		delete batoh2;
	}
	{
		Uloziste4<int> batoh(8);
		batoh.nastavData(10);
		cout << batoh.vratData() << endl;

		Uloziste4<float> batoh1(3.45);
		cout << batoh1.vratData() << endl;

		Uloziste4<string>* batoh2 = new Uloziste4<string>("sfdg");
		cout << batoh2->vratData() << endl;

		delete batoh2;
	}

	return 0;
}